      subroutine calfun(den,f,n)
	implicit double precision(a-h,o-z)
	double precision m, f(n), den(n),kappa,lambda
	common/scale/iscale1, iscale2
	common/temp/TK
	common/par/sigc,u0,m,e_ii,dmu,xp,v00
	common/par_assoc/kappa,epsilon,lambda
	common/results/pl,pv,rhol,rhov
	common/polarc/Apolar, Zpolar
	common/flag/iflag
	common/assoc/iassoc_flag, num_assoc_site
c
	rg = 82.0535d0
	tau = 0.74048d0
	BAR= 1.0d0 ! 0.986923	! Aleks noted
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143
c
	sigc2=(v00*6.0d0*0.74048d0/pi/AVOG)**(1.0D0/3.0D0)
	sig=sigc2*(1.0d0-0.12*exp(-3*u0/TK))
	!the densities do not contain the T-dependent part of the diameter (only sigc)
	rhol=(den(1)/(10.0d0**iscale1))
	rhov=(den(2)/(10.0d0**iscale2))

c	write(6,*)den(1), den(2)

	if ((den(1).le.0.0d0).or.(den(2).le.0.0d0)) then
		f(1)=100000.0d0
		f(2)=100000.0d0
		return
	end if

	eta = rhol*m*pi/6.0d0*(1.0d0-0.12*exp(-3*u0/TK))**3.0d0
	if (eta.gt.1.0d0) then
		f(1)=100000.0d0
		f(2)=100000.0d0
		return
	end if

	eta = rhov*m*pi/6.0d0*(1.0d0-0.12*exp(-3*u0/TK))**3.0d0
	if (eta.gt.1.0d0) then
		f(1)=100000.0d0
		f(2)=100000.0d0
		return
	end if

c
c	Calculations for liquid state
c
	rhox=rhol	
c	write(6,*)'rhox for thermoprops l:',rhox
	if(rhox.le.0.d0) then
c	write(6,*)'den(1):',den(1)
	f(1)=100000.d0
	f(2)=100000.d0
	return
      endif
	call thermo_props(m,rhox,xp,dmu,u0,v00,kappa,epsilon,lambda,e_ii,
     &	TK,zres,ares,dpdrho)
	gres=ares+zres
	rhol=rhox/((sigc2**3)*avog)
	pl=(zres+1.0d0) * rhol * rg * TK * 100.0d0/BAR 
	gl=gres+log(rhol) 
	
c	Calculations for vapor phase
c
	rhox=rhov
c	write(6,*)'rhox for thermoprops v:',rhox
	if(rhox.le.0.d0) then
c	write(6,*)'den(2):',den(2)
	f(1)=100000.d0
	f(2)=100000.d0
	return
      endif
	
	call thermo_props(m,rhox,xp,dmu,u0,v00,kappa,epsilon,lambda,e_ii,
     &	TK,zres,ares,dpdrho)
	gres=ares+zres
	rhov=rhox/((sigc2**3)*avog)
	pv=(zres+1.0d0) * rhov * rg * TK * 100.0d0/BAR 	
	gv=gres+log(rhov)
	if(abs((rhol-rhov)/rhol).le.1.0d-5) then
	f(1)=10000.0d0
	f(2)=10000.0d0
	return
	endif
	f(1)=pl-pv
	f(2)=gl-gv
	if(iflag.eq.1) then
	endif
	return
	end