df = 3.0d0 - 2.0d0 * eta

dyp = 2**h*h*(1 + (1 + (2*eta**4)/f**2)**0.5)**h* &
     &   (eta*f)**(-1 + h)* &
     &   (f + eta*df) + &
     &  (0.5*2**h*h*(1 + (1 + (2*eta**4)/f**2)**0.5)** &
     &      (-1 + h)*(eta*f)**h* &
     &     ((8*eta**3)/f**2 - &
     &       (4*eta**4*df)/f**3))/ &
     &   (1 + (2*eta**4)/f**2)**0.5

dym =  2**h*h*(-1 + (1 + (2*eta**4)/f**2)**0.5)**h* &
     &   (eta*f)**(-1 + h)* &
     &   (f + eta*df) + &
     &  (0.5*2**h*h*(-1 + &
     &        (1 + (2*eta**4)/f**2)**0.5)**(-1 + h)* &
     &     (eta*f)**h* &
     &     ((8*eta**3)/f**2 - &
     &       (4*eta**4*df)/f**3))/ &
     &   (1 + (2*eta**4)/f**2)**0.5

dzd = dyp - dym

dzs = dyp + dym

dA = (-2*eta + zd)/(1 - eta)**2 + &
     &  (-2 + dzd)/(1 - eta)

dB = (-2*eta - 0.5*zd)/(1 - eta)**2 + &
     &  (-2 - 0.5*dzd)/(1 - eta)

dC = (Sqrt(3.0d0)*zs)/(2.*(1 - eta)**2) + &
     &  (Sqrt(3.0d0)*dzs)/(2.*(1 - eta))


dt1 = -(2.0d0 * (1.0d0-A+dexp(gamma * A) * (lambda * A - 1.0d0)) * dA) / A**3.0d0 &
   &  + (-dA + dexp(gamma * A) * lambda * dA + dexp(gamma * A) * gamma * (lambda * A &
   &  - 1.0d0) * dA) / A**2.0d0

dt2 = -(((-B + dexp(gamma*B)*Lambda*(B*Cos(Gamma*C) + C*Sin(Gamma*C)))* &
     &       (2*B*dB + 2*C*dC))/(B**2 + C**2)**2) + &
     &  (2*(-B**2 + C**2 + dexp(Gamma*B)*((B**2 - C**2)*Cos(Gamma*C) + 2*B*C*Sin(Gamma*C)))* &
     &     (2*B*dB + 2*C*dC))/(B**2 + C**2)**3 + &
     &  (-dB + dexp(Gamma*B)*Gamma*Lambda*(B*Cos(Gamma*C) + C*Sin(Gamma*C))*dB + &
     &     dexp(Gamma*B)*Lambda*(Cos(Gamma*C)*dB + Gamma*C*Cos(Gamma*C)*dC + &
     &        Sin(Gamma*C)*dC - gamma*B*Sin(gamma*C)*dC))/(B**2 + C**2) - &
     &  (-2*B*dB + dexp(gamma*B)*gamma*((B**2 - C**2)*Cos(gamma*C) + 2*B*C*Sin(gamma*C))* &
     &      dB + 2*C*dC + &
     &     dexp(gamma*B)*(2*C*Sin(gamma*C)*dB + 2*gamma*B*C*Cos(gamma*C)*dC + &
     &        2*B*Sin(gamma*C)*dC - gamma*(B**2 - C**2)*Sin(gamma*C)*dC + &
     &        Cos(gamma*C)*(2*B*dB - 2*C*dC)))/(B**2 + C**2)**2

dt3 = -(((C + dexp(gamma*B)*lambda*(-(C*Cos(gamma*C)) + B*Sin(gamma*C)))* &
     &       (2*B*dB + 2*C*C))/(B**2 + C**2)**2) + &
     &  (2*(2*B*C + dexp(gamma*B)*(-2*B*C*Cos(gamma*C) + (B**2 - C**2)*Sin(gamma*C)))* &
     &     (2*B*dB + 2*C*C))/(B**2 + C**2)**3 + &
     &  (dexp(gamma*B)*gamma*lambda*(-(C*Cos(gamma*C)) + B*Sin(gamma*C))*dB + C + &
     &     dexp(gamma*B)*lambda*(Sin(gamma*C)*dB - Cos(gamma*C)*C + &
     &        gamma*B*Cos(gamma*C)*C + gamma*C*Sin(gamma*C)*C))/ &
     &   (B**2 + C**2) - (2*C*dB + &
     &     dexp(gamma*B)*gamma*(-2*B*C*Cos(gamma*C) + (B**2 - C**2)*Sin(gamma*C))*dB + &
     &     2*B*C + dexp(gamma*B)* &
     &      (-2*C*Cos(gamma*C)*dB - 2*B*Cos(gamma*C)*C + &
     &        gamma*(B**2 - C**2)*Cos(gamma*C)*C + &
     &        2*gamma*B*C*Sin(gamma*C)*C + &
     &        Sin(gamma*C)*(2*B*dB - 2*C*C)))/(B**2 + C**2)**2

da1 =  (2*(-2*eta*(1 - eta - 3*eta**2) + &
     &       (1 - 3*eta - 4*eta**2)*zd + &
     &       (1 + eta/2.)*zd**2))/ &
     &   (3.*(1 - eta)**3*(2*eta**2 + zd**2)) - &
     &  ((-2*eta*(1 - eta - 3*eta**2) + &
     &       (1 - 3*eta - 4*eta**2)*zd + &
     &       (1 + eta/2.)*zd**2)* &
     &     (4*eta + 2*zd*dzd))/ &
     &   (3.*(1 - eta)**2*(2*eta**2 + zd**2)**2) + &
     &  (-2*(-1 - 6*eta)*eta - 2*(1 - eta - 3*eta**2) + &
     &     (-3 - 8*eta)*zd + zd**2/2. + &
     &     (1 - 3*eta - 4*eta**2)*dzd + &
     &     2*(1 + eta/2.)*zd*dzd)/ &
     &   (3.*(1 - eta)**2*(2*eta**2 + zd**2))

da2 =  (2*(eta*(2 + 4*eta - 3*eta**2) - &
     &       (1 - 3*eta - 4*eta**2)*zd + &
     &       2*(1 + eta/2.)*zd**2))/ &
     &   (3.*(1 - eta)**3*(2*eta**2 + zd**2)) - &
     &  ((eta*(2 + 4*eta - 3*eta**2) - &
     &       (1 - 3*eta - 4*eta**2)*zd + & 
     &       2*(1 + eta/2.)*zd**2)* &
     &     (4*eta + 2*zd*dzd))/ &
     &   (3.*(1 - eta)**2*(2*eta**2 + zd**2)**2) + &
     &  (2 + 4*eta + (4 - 6*eta)*eta - 3*eta**2 - &
     &     (-3 - 8*eta)*zd + zd**2 - &
     &     (1 - 3*eta - 4*eta**2)*dzd + &
     &     4*(1 + eta/2.)*zd*dzd)/ &
     &   (3.*(1 - eta)**2*(2*eta**2 + zd**2))

da3 = (2*(eta*(2 - 5*eta**2)*zd + &
     &       (1 - 3*eta - 4*eta**2)*(4*eta**2 + zd**2) &
     &       ))/ &
     &   (Sqrt(3)*(1 - eta)**3*(2*eta**2 + zd**2)* &
     &     zs) - ((eta*(2 - 5*eta**2)*zd + &
     &       (1 - 3*eta - 4*eta**2)*(4*eta**2 + zd**2) &
     &       )*(4*eta + 2*zd*dzd))/ &
     &   (Sqrt(3)*(1 - eta)**2*(2*eta**2 + zd**2)**2* &
     &     zs) + (-10*eta**2*zd + &
     &     (2 - 5*eta**2)*zd + &
     &     (-3 - 8*eta)*(4*eta**2 + zd**2) + &
     &     eta*(2 - 5*eta**2)*dzd + &
     &     (1 - 3*eta - 4*eta**2)* &
     &      (8*eta + 2*zd*dzd))/ &
     &   (Sqrt(3)*(1 - eta)**2*(2*eta**2 + zd**2)* &
     &     zs) - ((eta*(2 - 5*eta**2)*zd + &
     &       (1 - 3*eta - 4*eta**2)*(4*eta**2 + zd**2) &
     &       )*dzs)/ &
     &   (Sqrt(3)*(1 - eta)**2*(2*eta**2 + zd**2)* &
     &     zs**2)






