      
	subroutine funfit(mm,nn,parfit,fdif)
	implicit double precision(a-h,o-z)
	parameter(n=2)
	double precision m,denf(2),f(2),fdif(mm),parfit(nn),kappa,lambda
	double precision fjac(2,2)
	double precision  den(2),df(2,2),fjac1(2,2)
	integer info(2,2)
	common/par/sigc,u0,m,e_ii,dmu,xp,v00
	common/par_assoc/kappa,epsilon,lambda
	common/output1/plcal1(500),rlcal1(500),rvcal1(500)
	common/output2/plcal2(500),rlcal2(500),rvcal2(500)
	common /tol1/ itmax
	common /tol2/ errrel
	common/scale/iscale1, iscale2
	common/results/pl,pv,rhol,rhov
	common/expdat1/tkdat1(500),rholdat1(500),pvdat1(500)
	common/expdat2/tkdat2(500),rholdat2(500),pvdat2(500)
	common/temp/TK
	common/nexp/ndp1, ndp2
	common/guess/den
	external calfun, calfunjac
c	
	rg = 82.0535d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143 
c
	
	v00=parfit(1)
	u0=parfit(2)
	m=parfit(3)
	kappa=parfit(4)
	epsilon=parfit(5)
c	xp=parfit(6)

	sigc=(v00*6.0d0*0.74048d0/pi/AVOG)**(1.0D0/3.0D0)


	if ((xp.gt.1.0d0).or.(xp.lt.0.0d0)) then
	 do index=1,mm
	  fdif(index)=100000
	 enddo
	 return
	endif

	sumdev=0.0d0
	devden=0.0d0
c
	den(1)=0.8d0/m      
      den(2)=0.001D0/m
	
c	write(6,*)'den1 = ',den(1)
c	write(6,*)'den2 = ',den(2)
	
	do 10 i=1,ndp1
	TK=tkdat1(i)
	iscalel = -int(log10(den(1)))
	iscale2 = -int(log10(den(2)))
	den(1) = den(1) * (10.0d0**iscale1)
	den(2) = den(2) * (10.0d0**iscale2)
	nvar=2

	iersvr=4
	ipact=0
	isact=0
	call ERSET (IERSVR, IPACT, ISACT)

	do ijk=1,50
	call dneqnf(calfun,errrel, n, itmax, den, denf, fnorm)
	icode=iercd()
c	write(6,*)'icode in dneqnf1 = ',icode
	if (icode.eq.0) exit
	den = 0.6*den + 0.4*denf
	end do
	if (icode.ne.0) write(6,*)'icode in dneqnf1 at exit = ',icode
!	write(6,*)'fnorm1 = ',fnorm
!	write(6,*)'denf = ', denf(1), denf(2)

	do k=1,2
	den(k)=denf(k)
	enddo
c	write(6,*)'den1, den2 = ',den(1), den(2)
	call calfun(den,f,n)
	plcal1(i)=pl
	rlcal1(i)=rhol
	rvcal1(i)=rhov
	fdif(i)=(pl-pvdat1(i))/pvdat1(i)
	sumdev=sumdev+((pl-pvdat1(i))/pvdat1(i))**2
c	devden=devden+((rhol-rholdat(i))/rholdat(i))**2
c
c	Unscale the densities now
c
	den(1)=den(1)/(10.0d0**iscale1)
	den(2)=den(2)/(10.0d0**iscale2)
	if(i.eq.1) then
	den1=den(1)
	den2=den(2)
	endif 	
 10	continue
c
	den(1)=den1
	den(2)=den2
c
	do 11 i=1,ndp2
	TK=tkdat2(i)
	iscalel = -int(log10(den(1)))
	iscale2 = -int(log10(den(2)))
	den(1) = den(1) * (10.0d0**iscale1)
	den(2) = den(2) * (10.0d0**iscale2)
	nvar=2

	iersvr=4
	ipact=0
	isact=0
	call ERSET (IERSVR, IPACT, ISACT)

	do ijk=1,5
	call dneqnf(calfun,errrel, n, itmax, den, denf, fnorm)
	icode=iercd()
	if (icode.eq.0) exit
	den = 0.5*den + 0.5*denf
	end do
	if (icode.ne.0) write(6,*)'icode in dneqnf2 at exit = ',icode
!	write(6,*)'fnorm2 = ',fnorm
!	write(6,*)'denf = ', denf(1), denf(2)
c
	do k=1,2
	den(k)=denf(k)
	enddo
	call calfun(den,f,n)
	
	plcal2(i)=pl
	rlcal2(i)=rhol
	rvcal2(i)=rhov
	fdif(ndp1+i)=(rhol-rholdat2(i))/rholdat2(i)
	devden=devden+((rhol-rholdat2(i))/rholdat2(i))**2
c
c	Unscale the densities now
c
	den(1)=den(1)/(10.0d0**iscale1)
	den(2)=den(2)/(10.0d0**iscale2)
	
 11	continue

	den(1)=den1
	den(2)=den2

	return
	end