	subroutine hsprops(m,eta,ahs,dahs_deta,d2ahs_deta2,d3ahs_deta3)
	
	Implicit double precision(a-h,o-z)
	
	double precision m
	
c
	rg = 83.14506585d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143
c
	!in this subroutine, the derivatives of zhs and ahs are taken wrt packing fraction
	!and not density, if wish derivatives wrt densitym multiply by deta/drho
c
      one_minus_eta = 1.0d0-eta
	!---free enerfy------------------------------------------

	ahs=(4.0D0*eta-3.0D0*eta**2)/one_minus_eta**2

	!----first derivative of a  wrt packing fraction---------

      dahs_deta=((4.0D0-6.0D0*eta)/one_minus_eta**2+
     &  2.0D0*(4.0D0*eta-3.0D0*eta**2)/one_minus_eta**3)

	!----second derivative of a wrt packing fraction---------

	d2ahs_deta2 = -6.0D0/one_minus_eta**2+4.0D0*(4.0D0-6.0D0*eta)/
     &	one_minus_eta**3+6.0D0*(4.0D0*eta-3.0D0*eta**2)/
     &    one_minus_eta**4

	!---third derivative of a wrt packing fraction-----------

	d3ahs_deta3 = (-36.0D0/one_minus_eta**3+18.0D0*(4.0D0-6.0D0*eta)
     &	/one_minus_eta**4+24.0D0*(4.0D0*eta-3.0D0*eta**2)/
     &    one_minus_eta**5)

	return
	end

