module essentials 

implicit none
!	Checking single & double precision
integer, parameter :: single = SELECTED_REAL_KIND(p=6, r=37)
integer, parameter :: double = SELECTED_REAL_KIND(p=13)

!	Declaring essential variables for thermo_props that's not temperature dependent

integer :: ncp
integer :: max
integer :: status11
integer :: disp_flag

real (KIND=double), dimension(4,9) :: D
real (KIND=double), dimension(50) :: m_tmp
real (KIND=double), dimension(50,50) :: u0_tmp
real (KIND=double), dimension(50) :: e_ii_tmp
real (KIND=double), dimension(50,50,8,8) :: kappa_tmp
real (KIND=double), dimension(50,50) :: sig_tmp
real (KIND=double), dimension(50) :: v00_tmp
real (KIND=double), dimension(50,50) :: kij_tmp
real (KIND=double), dimension(50) :: MW_tmp
real (KIND=double), dimension(50) :: alpha
integer, dimension(50) :: N_sites_tmp



!	Declaring essential variables that are T dependent
real (KIND=double) :: TK
real (KIND=double) :: rhox_tmp
real (KIND=double) :: PMn, PMw
real (KIND=double), dimension(50) :: x_tmp
real (KIND=double), dimension(50,50,8,8,2) :: fa_tmp, fa_tmp2
real (KIND=double), dimension(50,50,8,8) :: kappa_tmp2
real (KIND=double), dimension(50,50,8,8,1) :: fb_tmp, fb_tmp2


save
end module
