      subroutine calfunjac(n,den,fjac)
	Implicit double precision(a-h,o-z)
	double precision m, f(n), den(n), fjac(n,n)
	common/scale/iscale1, iscale2
	common/temp/TK
	common/par/sigc,u0,m,e_ii,dmu,xp
	common/results/pl,pv,rhol,rhov
c
	rg = 82.0535d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143
c
	sig=sigc*(1.0d0-0.12*exp(-3*u0/TK))	
	rhol1=(den(1)/(10.0d0**iscale1))*((sig/sigc)**3)
	rhov1=(den(2)/(10.0d0**iscale2))*((sig/sigc)**3)
	call thermo_props(m,rhol1,xp,dmu,u0,v00,kappa,epsilon,lambda,e_ii
     &	 ,TK,zresl,aresl,dpdrhol)
c	Convert to unit kPa mol^(-1) cm^(+3)
	dgdrhol=(dpdrhol/rhol1)*((sig/sigc)**3)
	dpdrhol=dpdrhol*R1*TK*(1.0D+3)
	call thermo_props(m,rhov1,xp,dmu,u0,v00,kappa,epsilon,lambda,e_ii
     &	,TK,zresv,aresv,dpdrhov)
	dgdrhov=dpdrhov/rhov1
	dpdrhov=dpdrhov*R1*TK*(1.0D+3)
	fjac(1,1)=dpdrhol/((sigc**3)*avog*(10.0d0**iscale1))
	fjac(1,2)=-dpdrhov/((sigc**3)*avog*(10.0d0**iscale2))
	fjac(2,1)=dgdrhol*((sig/sigc)**3)*1.0/(10**iscale1)
	fjac(2,2)=-dgdrhov*((sig/sigc)**3)*1.0/(10**iscale2)
	return
	end
		