c----------------------------------------------------------------------
	subroutine chain(m,eta,achain,dachain_deta,d2achain_deta2,
     &	d3achain_deta3)

	implicit double precision (a-h,o-z)

	double precision m
c	
	rg = 83.14506585d0
	tau = 0.74048d0
	BAR=0.986923
	AVOG=0.602252d0
	pi = 3.141592654d0
	R1=8.3143
c
	!in this subroutine, the derivatives of zchain and achain are taken wrt packing fraction
	!and not density, if wish derivatives wrt densitym multiply by deta/drho
c
      one_minus_eta = 1.0d0 - eta
	!---rdg and its derivatives wrt eta-------------------------------
	
	ghs=(1-eta/2)/((1-eta)**3)

	dg_deta=-1.0D0/(2.0D0*one_minus_eta**3)+3*(1.0D0-0.5D0*eta)
     &	/one_minus_eta**4

	d2g_deta2 = -3.0D0/one_minus_eta**4+12.0D0*(1.0D0-0.5D0*eta)/
     &	one_minus_eta**5
	d3g_deta3 = -18.0D0/one_minus_eta**5+60.0D0*(1.0D0-0.5D0*eta)
     &	/one_minus_eta**6

	!---chain term contributions--------------------------------------

	achain=(1.0d0-m)*dlog(ghs)


	!----first derivatives of a wrt packing fraction------------------

      dachain_deta=(1.0d0-m)/ghs*dg_deta

	!---second derivative of a wrt pakcking fraction------------------

	d2achain_deta2 = (1.0d0-m)/ghs*(d2g_deta2-(dg_deta**2)/ghs)

	!---third derivative of a wrt packing fraction--------------------
	
	d3achain_deta3 = (1.0D0-m)/ghs*(d3g_deta3-
     &3.0D0*(dg_deta*d2g_deta2)/ghs+2.0D0*dg_deta**3/ghs**2)
    
      
c
	return
	end
