SUBROUTINE KB_calc(KB_result, ncp, TK, rhox, x, m, e_ii, sig, u0, 


!	This subroutine calculates the KB value used in polydisperse SAFT calculations

implicit none

!	Checking single & double precision
integer, parameter :: single = SELECTED_REAL_KIND(p=6, r=37)
integer, parameter :: double = SELECTED_REAL_KIND(p=13)

!	Declaring calling variables
integer, intent(in) :: ncp									! number of components
real (KIND=double), intent(in) :: TK, rhox
real (KIND=double), intent(in), dimension(ncp) :: x, m, e_ii
real (KIND=double), intent(in), dimension(ncp, ncp) :: sig, u0
real (KIND=double), intent(out) :: KB_result				

!	Declare local parameter
real (KIND=double), parameter :: pi = 3.141592654d0
real (KIND=double) :: pi_over6 = pi / 6.0D0


!	Declaring local variables
real (KIND=double) :: Zhs


!	Meat starts here
Zhs = 2.0d0/3.0d0*pi*rhox* 

muHS = pi*rhox/6.0d0*

